
// CCCDlg.cpp : implementation file
//

#include "pch.h"
#include "framework.h"
#include "CCC.h"
#include "CCCDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// Dialog Data
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CCCCDlg dialog



CCCCDlg::CCCCDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_CCC_DIALOG, pParent)
	, m_nCellX(0)
	, m_nCellY(0)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCCCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_OutputImage, m_cPic1);
	DDX_Text(pDX, IDC_EDIT2, m_nCellX);
	DDX_Text(pDX, IDC_EDIT3, m_nCellY);
}

BEGIN_MESSAGE_MAP(CCCCDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, &CCCCDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_Encode, &CCCCDlg::OnBnClickedEncode)
	ON_BN_CLICKED(IDC_SaveBmpButton, &CCCCDlg::OnBnClickedSavebmpbutton)
	ON_BN_CLICKED(IDC_SaveDataButton, &CCCCDlg::OnBnClickedSavedatabutton)
	ON_BN_CLICKED(IDC_OpenDataFile, &CCCCDlg::OnBnClickedOpendatafile)
END_MESSAGE_MAP()


// CCCCDlg message handlers

BOOL CCCCDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here
	m_nCellX = 16;
	m_nCellY = 16;

	UpdateData(false);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CCCCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CCCCDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CCCCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



void CCCCDlg::OnBnClickedButton1()
{
	UpdateData(true);
	{//load image
		CString filenameLeft;
		CFileDialog cfdLeft(true, NULL, m_sPath, NULL, L"256 color Bitmap (*.bmp)|*.bmp|All Files (*.*)|*.*||");
		if (cfdLeft.DoModal() == IDOK)
		{//got a file 
			filenameLeft = cfdLeft.GetPathName();
			m_sFilename = filenameLeft;
			if (!m_image.IsNull())
				m_image.Destroy();  //delete existing bitmap in order to load a new one
			if (m_image.Load(filenameLeft) == S_OK)
			{
				m_sPath = filenameLeft;
				m_cPic1.SetBitmap((HBITMAP)CopyImage(HBITMAP(m_image), IMAGE_BITMAP, m_image.GetWidth(), m_image.GetHeight(), 0));
				UpdateData(false);
				Invalidate();

			}
			else
			{
				AfxMessageBox(L"File not found or invalid format");
			}
		};
	}
}


void CCCCDlg::OnBnClickedEncode()
{
	UpdateData(true);

	//Check image for correct type
	int bpp = m_image.GetBPP();
	if (bpp != 8)
	{
		MessageBox(L"Sorry, image must be an 8bpp (256 color) bitmap");
		return;
	}
	//Check that dimensions are multiple of 4
	int xcells = m_image.GetWidth()/m_nCellX;
	if ((xcells * m_nCellX) != m_image.GetWidth())
	{
		MessageBox(L"Sorry, image width must be factor of Cell X");
		return;
	}
	int ycells = m_image.GetHeight() / m_nCellY;
	if ((ycells * m_nCellY) != m_image.GetHeight())
	{
		MessageBox(L"Sorry, image height must be factor of Cell Y");
		return;
	}

	//convert 8bpp source to Color Cell Compressed version
	m_image.GetColorTable(0, 256, m_palette);
	//create a table of lumina values for each palette member
	float PalLuma[256];
	int r, g, b;
	for (int i = 0; i < 256; i++)
	{
		r = m_palette[i].rgbRed;
		g = m_palette[i].rgbGreen;
		b = m_palette[i].rgbBlue;
		PalLuma[i] = r * 0.30 + g * 0.59 + b * 0.11;
	}
	//Form cells
	int x, y;
	int ngroup[32*32];  //Assuming some maximum cell size
	int n;

	int cbits = 0;

	for (int yc = 0; yc < ycells; yc++)
		for (int xc = 0; xc < xcells; xc++)
		{
			//first get average luma of cell
			float avluma = 0;
			COLORREF c;
			for (int i=0;i<m_nCellX;i++)
			{
				x = xc * m_nCellX + i;
				for (int j = 0; j < m_nCellY; j++)
				{
					y = yc * m_nCellY + j;
					
					//check that doing it right here:
					//c = m_image.GetPixel(x, y);
					//r = GetRValue(c);
					//g = GetGValue(c);
					//b = GetBValue(c);
					//float l1 = r * 0.30 + g * 0.59 + b * 0.11;
					//Note:  l1 should equal l2

					unsigned char* c1 = (unsigned char *) m_image.GetPixelAddress(x, y);
					float l2 = PalLuma[*c1];
					avluma += l2;
				}
			}
			
			//divide sum by 16 to get average luma of cell
			avluma = avluma / (m_nCellY* m_nCellX);
			
			//Now, assign pixels to either group 1 or group 2
			for (int j = 0; j < m_nCellY; j++)
			
			{
				
				y = yc * m_nCellY + j;
				for (int i = 0; i < m_nCellX; i++)
				{
					x = xc * m_nCellX + i;
					n = j * m_nCellX + i;//pixel cell index = n
					unsigned char* c1 = (unsigned char*)m_image.GetPixelAddress(x, y);
					float l2 = PalLuma[*c1];
					if (l2 > avluma)
						ngroup[n] = 2; //group 2 is above average luma
					else
						ngroup[n] = 1; //group 1 is below average luma
				}
			}

	//Now, split group 1  in two to have 2bpp color
			//first get average luma of cell for group 1
			avluma = 0;
			int nGroup = 0;
			for (int i = 0; i < m_nCellX; i++)
			{
				x = xc * m_nCellX + i;
				for (int j = 0; j < m_nCellY; j++)
				{
					y = yc * m_nCellY + j;
					n = j * m_nCellX + i;//pixel cell index = n

					if (ngroup[n]==1)
					{
						unsigned char* c1 = (unsigned char*)m_image.GetPixelAddress(x, y);
						float l2 = PalLuma[*c1];
						avluma += l2;
						nGroup++;
					}
				}
			}
			//divide sum by count to get average
			if (nGroup > 0)
				avluma = avluma / nGroup;
			else
				avluma = 0;

			//Now, assign group 1 pixels to either group 1 or group 3
			for (int j = 0; j < m_nCellY; j++)

			{

				y = yc * m_nCellY + j;
				for (int i = 0; i < m_nCellX; i++)
				{
					x = xc * m_nCellX + i;
					n = j * m_nCellX + i;//pixel cell index = n
					unsigned char* c1 = (unsigned char*)m_image.GetPixelAddress(x, y);
					float l2 = PalLuma[*c1];
					if (ngroup[n]==1)
						if (l2 > avluma)
							ngroup[n] = 3; //group 3 is above average luma
						else
							ngroup[n] = 1; //group 1 is below average luma
				}
			}



	//Now, split group 2  in two to have 2bpp color
			//first get average luma of cell for group 1
			avluma = 0;
			nGroup = 0;
			for (int i = 0; i < m_nCellX; i++)
			{
				x = xc * m_nCellX + i;
				for (int j = 0; j < m_nCellY; j++)
				{
					y = yc * m_nCellY + j;
					n = j * m_nCellX + i;//pixel cell index = n

					if (ngroup[n] == 2)
					{
						unsigned char* c1 = (unsigned char*)m_image.GetPixelAddress(x, y);
						float l2 = PalLuma[*c1];
						avluma += l2;
						nGroup++;
					}
				}
			}
			//divide sum by count to get average
			if (nGroup > 0)
				avluma = avluma / nGroup;
			else
				avluma = 0;

			//Now, assign group 1 pixels to either group 1 or group 3
			for (int j = 0; j < m_nCellY; j++)

			{

				y = yc * m_nCellY + j;
				for (int i = 0; i < m_nCellX; i++)
				{
					x = xc * m_nCellX + i;
					n = j * m_nCellX + i;//pixel cell index = n
					unsigned char* c1 = (unsigned char*)m_image.GetPixelAddress(x, y);
					float l2 = PalLuma[*c1];
					if (ngroup[n] == 2)
						if (l2 > avluma)
							ngroup[n] = 2; //group 2 is above average luma
						else
							ngroup[n] = 4; //group 4 is below average luma
				}
			}

			//Now, get average rgb value for all groups
			int ngroup1 = 0;
			int ngroup2 = 0;
			int ngroup3 = 0;
			int ngroup4 = 0;

			int r1=0, b1=0, g1=0;
			int r2=0, b2=0, g2=0;
			int r3 = 0, b3 = 0, g3 = 0;
			int r4 = 0, b4 = 0, g4 = 0;


			for (int i = 0; i < m_nCellX; i++)
			{
				x = xc * m_nCellX + i;
				for (int j = 0; j < m_nCellY; j++)
				{
					y = yc * m_nCellY + j;
					n = j * m_nCellX + i;//pixel cell index = n
					c = m_image.GetPixel(x, y);
					r = GetRValue(c);
					g = GetGValue(c);
					b = GetBValue(c);
					if (ngroup[n] == 1)
					{//group 1 pixel
						ngroup1 += 1;
						r1 += r;
						b1 += b;
						g1 += g;
					}
					else if (ngroup[n] == 2)
					{//group 2 pixel
						ngroup2 += 1;
						r2 += r;
						b2 += b;
						g2 += g;
					}
					else if (ngroup[n] == 3)
					{//group 3 pixel
						ngroup3 += 1;
						r3 += r;
						b3 += b;
						g3 += g;
					}
					else 
					{//group 4 pixel
						ngroup4 += 1;
						r4 += r;
						b4 += b;
						g4 += g;
					}
				}
			}

			//Now pick best color to represent each group
			int index1, index2, index3, index4;
			if (ngroup1 > 0)
			{
				r1 = r1 / ngroup1;
				b1 = b1 / ngroup1;
				g1 = g1 / ngroup1;
			}
			if (ngroup2 > 0)
			{
				r2 = r2 / ngroup2;
				b2 = b2 / ngroup2;
				g2 = g2 / ngroup2;
			}
			if (ngroup3 > 0)
			{
				r3 = r3 / ngroup3;
				b3 = b3 / ngroup3;
				g3 = g3 / ngroup3;
			}
			if (ngroup4 > 0)
			{
				r4 = r4 / ngroup4;
				b4 = b4 / ngroup4;
				g4 = g4 / ngroup4;
			}
			index1 = PickBestPaletteMatch(r1, g1, b1);
			index2 = PickBestPaletteMatch(r2, g2, b2);
			index3 = PickBestPaletteMatch(r3, g3, b3);
			index4 = PickBestPaletteMatch(r4, g4, b4);

			//Now, replace pixels with their assigned color
			
			for (int j = 0; j < m_nCellY; j++)
			{
				
				y = yc * m_nCellY + j;
				for (int i = 0; i < m_nCellX; i++)
				{
					x = xc * m_nCellX + i;
					n = j * m_nCellX + i;//pixel cell index = n
					unsigned char* c1 = (unsigned char*)m_image.GetPixelAddress(x, y);
					if (ngroup[n] == 1)
						*c1 = index1;
					else if (ngroup[n] == 2)
						*c1 = index2;
					else if (ngroup[n] == 3)
						*c1 = index3;
					else if (ngroup[n] == 4)
						*c1 = index4;
					else
					{
						//AfxMessageBox(L"Unassigned pixel!");
						*c1 = index4;
					}
				}
			}



			//Each tile is 16 bits and two colors
			//16 bits is two 8-bit chars
			int ncell = yc * xcells + xc;
			unsigned char d=0;

			int CharsPerCell = m_nCellY * m_nCellX / 4;

			//#chars per cell is now m_nCellY*m_nCellX/4
			//first char of 2bpp data
			int off = 0;


			
			for (int j = 0; j < m_nCellY; j++)
			{
				
				for (int i = 0; i < m_nCellX; i+=4)
				{
					
					n = j * m_nCellX + i;//pixel cell index = n
					d = 0;
					for (int k = 0; k < 4; k++)
					{
						if (ngroup[off+3-k] == 2)
							d = d * 4 + 1;
						else if (ngroup[off + 3 - k] == 3)
							d = d * 4 + 2;
						else if (ngroup[off + 3 - k] == 4)
							d = d * 4 + 3;
						else 
							d = d * 4 + 0;
					}
					off += 4;
					///n
					m_bits[cbits++] = d;

				}
			}

			//save colors
			m_colors[4 * ncell + 0] = index4;
			m_colors[4 * ncell + 1] = index3;
			m_colors[4 * ncell + 2] = index2;
			m_colors[4 * ncell + 3] = index1;




		}


		MessageBox(L"Encoding complete.");

		//Update screen
		m_cPic1.SetBitmap((HBITMAP)CopyImage(HBITMAP(m_image), IMAGE_BITMAP, m_image.GetWidth(), m_image.GetHeight(), 0));
		UpdateData(false);
		Invalidate();
}

int CCCCDlg::PickBestPaletteMatch(int r1, int g1, int b1)
{
	int minerror = MAXINT;
	int minindex = 0;
	int r, g, b;
	int error;
	for (int i = 0; i < 256; i++)
	{//scan palette for best match
		r = m_palette[i].rgbRed;
		g = m_palette[i].rgbGreen;
		b = m_palette[i].rgbBlue;
		error = (r1 - r) * (r1 - r) + (g1 - g) * (g1 - g) + (b1 - b) * (b1 - b);
		if (error < minerror)
		{//Best so far?
			minerror = error;
			minindex = i;
		}
	}
	return minindex; 
}

#include "Gdiplusimaging.h"  //needed for ImageFormatBMP definition

void CCCCDlg::OnBnClickedSavebmpbutton()
{
	CFileDialog cfd(false, L"bmp", m_sFilename, OFN_OVERWRITEPROMPT, L"Bitmap File (*.bmp)|*.bmp|All Files (*.*)|*.*||");
	if (cfd.DoModal() == IDOK)
	{//got a file 
		CString filenameOut = cfd.GetPathName();
		m_image.Save(filenameOut, Gdiplus::ImageFormatBMP);
		MessageBox(L"Save to file complete.");
	};
}



void CCCCDlg::OnBnClickedSavedatabutton()
{
	UpdateData(true);
	CFileDialog cfd(false, L"cc4", m_sFilename, OFN_OVERWRITEPROMPT, L"2bbp Color Cell Compressed Bitmap (*.cc4)|*.cc4|All Files (*.*)|*.*||");
	if (cfd.DoModal() == IDOK)
	{//got a file 
		CString filenameOut = cfd.GetPathName();
		CFile f(filenameOut, CFile::modeCreate | CFile::modeWrite);
		int xcells = m_image.GetWidth();// / m_nCellX;
		int ycells = m_image.GetHeight();// / m_nCellY;
		int nBytes = xcells * ycells / 4;

		xcells = m_image.GetWidth() / m_nCellX;
		ycells = m_image.GetHeight() / m_nCellY;

		//Write a header (8 longs = 32 bytes)
		char c[5]="CC4 ";
		f.Write(&c, 4);
		f.Write(&m_nCellX, 4);
		f.Write(&m_nCellY, 4);
		f.Write(&xcells, 4);
		f.Write(&ycells, 4);
		int reserved1, reserved2, reserved3;
		reserved1 = 0;
		reserved2 = 0;
		reserved3 = 0;
		f.Write(&reserved1, 4);
		f.Write(&reserved2, 4);
		f.Write(&reserved3, 4);

		//Write Palette
		f.Write(m_palette, 256 * 4); //write out palette as 256 longs

		//Write cell color assignements
		for (int yc = 0; yc < ycells; yc++)
			for (int xc = 0; xc < xcells; xc++)
			{//16x16x2bpp bitmap data = 64 bytes per cell, need to write the index of the two colors instead of the colors
				int ncell = yc * xcells + xc;
				f.Write(&m_colors[4 * ncell + 0], 4);
			}
		
		//Write 2bpp data
		f.Write(&m_bits[0], nBytes);

		f.Close();

		//CFile f2(filenameOut+L".pal", CFile::modeCreate | CFile::modeWrite);
		//f2.Write(m_palette, 256*4); //write out palette as 256 longs
		//f2.Close();

		//CFile f3(filenameOut+L".clr", CFile::modeCreate | CFile::modeWrite);
		////f.Write(m_palette, 256*4); //write out palette as 256 longs
		////now write out data in way that can be decompressed in real time

		//for (int yc = 0; yc < ycells; yc++)
		//	for (int xc = 0; xc < xcells; xc++)
		//		//{//4 bytes per cell, two as 4x4x1bpp bitmap and two 8-bit color indices
		//		//	int ncell = yc * xcells + xc;
		//		//	f.Write(&m_colors[2 * ncell + 0], 2);
		//		//	f.Write(&m_bits[2 * ncell + 0], 2);
		//		//}
		//	{//16x16x2bpp bitmap data = 64 bytes per cell, need to write the index of the two colors instead of the colors
		//		int ncell = yc * xcells + xc;
		//		f3.Write(&m_colors[4 * ncell + 0], 4);

		//	}
		//f3.Close();

		MessageBox(L"Save to file complete.");
	};
}


void CCCCDlg::OnBnClickedOpendatafile()
{
	//UpdateData(true);
	////clear current image and create new one from file
	//int lastw = m_image.GetWidth();
	//int lasth = m_image.GetHeight();
	//if ((lastw * lasth) == 0)
	//{
	//	MessageBox(L"Error.  Load bmp image in desired resolution first...");
	//	return;
	//}
	m_image.Destroy();
	//m_image.Create(lastw, lasth, 8);
	{//load image
		CString filenameLeft;
		CFileDialog cfdLeft(true, NULL, m_sPath, NULL, L"2bpp CCC encoded Bitmap (*.cc4)|*.cc4|All Files (*.*)|*.*||");
		if (cfdLeft.DoModal() == IDOK)
		{//got a file 
			CString filenameIn = cfdLeft.GetPathName();
			CFile f(filenameIn, CFile::modeRead);

			int xcells, ycells;
			char c[5];
			int reserved[3];
			f.Read(&c, 4);
			f.Read(&m_nCellX, 4);
			f.Read(&m_nCellY, 4);
			f.Read(&xcells, 4);
			f.Read(&ycells, 4);
			f.Read(&reserved, 4*3);


			//read in palette
			f.Read(m_palette, 256 * 4);//read in palette

			//Read cell color assignements
			for (int yc = 0; yc < ycells; yc++)
				for (int xc = 0; xc < xcells; xc++)
				{//16x16x2bpp bitmap data = 64 bytes per cell, need to write the index of the two colors instead of the colors
					int ncell = yc * xcells + xc;
					f.Read(&m_colors[4 * ncell + 0], 4);
				}

			//Read 2bpp data
			int nBytes = xcells*m_nCellX * ycells * m_nCellY / 4;
			f.Read(&m_bits[0], nBytes);

			f.Close();


			//apply data to new image
			m_image.Create(xcells * m_nCellX, ycells * m_nCellY, 8);
			int ngroup[16];
			int x, y, n;
			m_image.SetColorTable(0, 256, m_palette);
			for (int yc = 0; yc < ycells; yc++)
				for (int xc = 0; xc < xcells; xc++)
				{//16x16x2bpp bitmap data = 64 bytes per cell
					int ncell = yc * xcells + xc;
					//Note sure why these are backwards!
					unsigned char index4 = m_colors[4 * ncell + 0];
					unsigned char index3 = m_colors[4 * ncell + 1];
					unsigned char index2 = m_colors[4 * ncell + 2];
					unsigned char index1 = m_colors[4 * ncell + 3];
					//unsigned char d1 = m_bits[2 * ncell + 0];
					//unsigned char d2 = m_bits[2 * ncell + 1];

					//for (int i = 0; i < 8; i++)
					//{//unpack bits into 16 element array
					//	if ((d1 & 1) > 0)
					//		ngroup[7-i] = 2;
					//	else
					//		ngroup[7-i] = 1;
					//	if ((d2 & 1) > 0)
					//		ngroup[7-i + 8] = 2;
					//	else
					//		ngroup[7-i + 8] = 1;
					//	d1 = d1 / 2;
					//	d2 = d2 / 2;
					//}

					//Now, replace pixels with their assigned color
					int i;
					for (int j = 0; j < m_nCellY; j++)
					{
						y = yc * m_nCellY + j;
						for (int i = 0; i < 4; i++)
						{
							unsigned char d = m_bits[64* (xc + yc * xcells) + j * 4 + i];
							for (int k = 0; k < 4; k++)
							{
								x = xc * m_nCellX + i * 4 + k;
								unsigned char* c1 = (unsigned char*)m_image.GetPixelAddress(x, y);
								int c = d & 3;
								if (c == 0)
									*c1 = index1;
								else if (c == 1)
									*c1 = index2;
								else if (c == 2)
									*c1 = index3;
								else if (c == 3)
									*c1 = index4;
								d >>= 2;
							}
						}
					}
				}



			//Update screen
			m_cPic1.SetBitmap((HBITMAP)CopyImage(HBITMAP(m_image), IMAGE_BITMAP, m_image.GetWidth(), m_image.GetHeight(), 0));
			UpdateData(false);
			Invalidate();
		}
	}
}
